XPExtended_ShowText = "true"
XPExtended_ShowRep = "true"
XPExtended_TextSize = 12;

-- Local variables for Register in myAddOns & Initialize
local XPEXTENDED_NAME = "XPExtended";
local XPEXTENDED_VERSION = "2.0.6";
local XPEXTENDED_RELEASE_DATE = "June 23th, 2017";
local XPEXTENDED_AUTHOR = "Zilver"; -- Original Authers: Daniel Stephens & Xinhuan
local XPEXTENDED_EMAIL = "GoaHead.Hansen@Gmail.com";
local XPEXTENDED_WEBSITE = "http://ui.worldofwar.net/ui.php?id=2493";
local XPEXTENDED_LOADED = "XPExtended v" .. XPEXTENDED_VERSION .. " loaded";
local XPEXTENDED_CATEGORY_DEVELOPMENT = "Interface Enhancements";

-- Local variables
local oldWatchBarUpdate = ReputationWatchBar_Update;

-- round <-- from sea to make the mod independent
function pct_round(x)
	if(x - math.floor(x) > 0.5) then
		x = x + 0.5;
	end
	return math.floor(x);
end

-- OnLoad
function XPExtended_OnLoad()
	XPExtendedExpBarOverlayFrame:RegisterEvent("ADDON_LOADED");
	XPExtendedExpBarOverlayFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
	XPExtendedExpBarOverlayFrame:RegisterEvent("PLAYER_LEAVING_WORLD");
	SlashCmdList["XPEXTENDEDCOMMAND"] = XPExtended_SlashHandler;
	SLASH_XPEXTENDEDCOMMAND1 = "/xpextended";
	SLASH_XPEXTENDEDCOMMAND2 = "/xpe";
end

-- OnEvent
function XPExtended_Event(event)
	if (Event == "PLAYER_LEAVING_WORLD") then
		-- What events for the XP display routines
		XPExtendedExpBarOverlayFrame:UnregisterEvent("PLAYER_XP_UPDATE");
		XPExtendedExpBarOverlayFrame:UnregisterEvent("PLAYER_LEVEL_UP");
		XPExtendedExpBarOverlayFrame:UnregisterEvent("PLAYER_UPDATE_RESTING");
		XPExtendedExpBarOverlayFrame:UnregisterEvent("UPDATE_EXHAUSTION");

		-- What events for the reputation repeat messages
		XPExtendedRepBarOverlayFrame:UnregisterEvent("UPDATE_FACTION");
		XPExtendedRepBarOverlayFrame:UnregisterEvent("FACTION_STANDING_INCREASED");
		XPExtendedRepBarOverlayFrame:UnregisterEvent("FACTION_STANDING_DECREASED");
		return;

	elseif (event == "ADDON_LOADED" and arg1 == XPEXTENDED_NAME) then
		-- Initialize the addon
		XPExtended_Initialize();
			if (XPExtended_ShowText == "false") then
				XPExtendedOverlayFrame:Hide();
			end
			if (XPExtended_ShowRep == "false") then
				XPExtendedReputationFrame:Hide();
			end
		return;

	elseif (event == "PLAYER_ENTERING_WORLD")  then
		-- What events for the XP display routines
		XPExtendedExpBarOverlayFrame:RegisterEvent("PLAYER_XP_UPDATE");
		XPExtendedExpBarOverlayFrame:RegisterEvent("PLAYER_LEVEL_UP");
		XPExtendedExpBarOverlayFrame:RegisterEvent("PLAYER_UPDATE_RESTING");
		XPExtendedExpBarOverlayFrame:RegisterEvent("UPDATE_EXHAUSTION");

		-- What events for the reputation repeat messages
		XPExtendedRepBarOverlayFrame:RegisterEvent("UPDATE_FACTION");
		XPExtendedRepBarOverlayFrame:RegisterEvent("FACTION_STANDING_INCREASED");
		XPExtendedRepBarOverlayFrame:RegisterEvent("FACTION_STANDING_DECREASED");
		XPExtended_Update();
		XPExtended_Rep_Update();
		-- ReputationWatchBar_Update();
		return;

	-- Player XP Updates
	elseif ((event == "PLAYER_XP_UPDATE")
		or (event == "PLAYER_LEVEL_UP")
		or (event == "PLAYER_UPDATE_RESTING")
		or (event == "UPDATE_EXHAUSTION")) then
		XPExtended_Update();
		return;

	-- Player Reputation Updates
	elseif ((event == "UPDATE_FACTION")
		or (event == "FACTION_STANDING_INCREASED")
		or (event == "FACTION_STANDING_DECREASED")) then
		XPExtended_Rep_Update();
		-- ReputationWatchBar_Update();
		return;
	end
	XPExtendedOptions_Vars()
end

-- Update
function XPExtended_Update()
	local currXP = UnitXP("player");
	local nextXP = UnitXPMax("player");
	local playerLVL = UnitLevel("player");
	local nextLVL = ((playerLVL)+1);
	local togoRestedXP = GetXPExhaustion();
	local percentXP = pct_round((UnitXP("player")/UnitXPMax("player"))*1000);
	percentXP = percentXP/10;
		if (not togoRestedXP or togoRestedXP <= 0) then
			percentRestedXP = 0;
			togoRestedXP = 0;
			RestedXPExtendedExpText:SetText("");
			else
			local percentRestedXP = pct_round((GetXPExhaustion()*1000)/(UnitXPMax("player")*1.5));
			percentRestedXP = percentRestedXP/10;
			if (((GetXPExhaustion()*100)/(UnitXPMax("player")*1.5)) == 100) then
				RestedXPExtendedExpText:SetText("( |CFFFF8000" .. percentRestedXP .. " %|r  /  " .. togoRestedXP .. " )");
				else
				RestedXPExtendedExpText:SetText("( " .. percentRestedXP .. " %  /  " .. togoRestedXP .. " )");
				end
		end
	local togoXP = nextXP - currXP;
		if (togoXP < 0) then
			togoXP = 0;
		end
	XPExtendedExpText:SetText("( " .. percentXP .. " % / " .. togoXP .. " / Lvl: " .. playerLVL .. " )");
end

-- Update Rep
function XPExtended_Rep_Update()
-- ReputationWatchBar_Update(newLevel)
	local name, reaction, min, max, value = GetWatchedFactionInfo();
		if (name) then
			local togoRep = max - value;
			local newmax = max - min;
			local newvalue = newmax - togoRep;
			local percentRep = pct_round((newvalue/newmax)*1000);
			percentRep = percentRep/10;
			if (togoRep < 0) then
				togoRep = 0;
			elseif (togoRep == 0) then
				percentRep = 100;
			end
			XPExtendedRepText:SetText("( " .. percentRep .. " % / " .. togoRep .. " )");
			else
			XPExtendedRepText:SetText("");
		end
		if (name) and (reaction) then
			local standingID = reaction;
			if (standingID == 0) then
				standing = "Unknown";
			end
			if (standingID == 1) then
				standing = "|CFFFF0000Hated|r";
			end
			if (standingID == 2) then
				standing = "Hostile";
			end
			if (standingID == 3) then
				standing = "Unfriendly";
			end
			if (standingID == 4) then
				standing = "Neutral";
			end
			if (standingID == 5) then
				standing = "Friendly";
			end
			if (standingID == 6) then
				standing = "Honored";
			end
			if (standingID == 7) then
				standing = "Revered";
			end
			if (standingID == 8) then
				standing = "|CFFFF8000Exalted|r";
			end
			XPExtendedStandingText:SetText("( " .. standing .. " by " .. name .. " )");
			else
		end
end

-- SlashHandler
function XPExtended_SlashHandler(msg)
	XPExtendedOptions:Show();
end

-- Initialize
function XPExtended_Initialize()
	-- Check if myAddOns is loaded
	if (myAddOnsFrame_Register) then
		-- Initialize the addon's details
		local XPExtendedDetails = {
			name = XPEXTENDED_NAME,
			version = XPEXTENDED_VERSION,
			releaseDate = XPEXTENDED_RELEASE_DATE,
			author = XPEXTENDED_AUTHOR,
			email = XPEXTENDED_EMAIL,
			website = XPEXTENDED_WEBSITE,
			category = XPEXTENDED_CATEGORY_DEVELOPMENT
		};
		-- Register the addon in myAddOns
		myAddOnsFrame_Register(XPExtendedDetails);
	else
		-- Display a message in the ChatFrame indicating a successful load of the addon
		DEFAULT_CHAT_FRAME:AddMessage(XPEXTENDED_LOADED, 1.0, 1.0, 0.0);
	end
end